#pragma once

#include "../resource.h"
/*
	CCloseTitlesOption
	^Cgɂ\}~̂߂̃f[^x[XƋ@\NX

	\֎~y[W^Cg̃Xgƌ@\A
	Xg̃t@Cւ̓ǂݏ@\L܂B

	g̓VvŁAvOJnGetProfileAIWriteProfileĂяo܂B
	Ƃ̓y[WJۂɂ̃^CgSearchStringŌāA
	trueԂ΃y[WĴLZ鏈΂킯łB
*/
class CCloseTitlesOption
{
public:
	typedef std::list<CString> CStringList;	//^CgXǧ^
	static CStringList* s_pCloseTitles;		//^CgXg
	static bool s_bValid;					//̋@\͗Lł邩

	static void GetProfile();				//t@C̃Xgǂݍݑ
	static void WriteProfile();				//t@Cւ̃XgoI
	static bool SearchString(const CString& strTitle);	//^Cǧ
	static void Add(const CString& strTitle);			//Xgւ̍ڒǉ
};


/*
	CCloseTitlesPropertyPage
	y[W^Cgɂ\}~ݒ肷邽߂̃vpeBx[W_CAONX

	\֎~^Cg̈ꗗҏW邽߂̃_CAO
*/
class CCloseTitlesPropertyPage : public CPropertyPageImpl<CCloseTitlesPropertyPage>,
	public CWinDataExchange<CCloseTitlesPropertyPage>
{
private:
	//oϐ
	CCloseTitlesOption::CStringList m_urls;	//֎~^Cg̃Xg(͂Ƃ)
	CString m_strAddressBar;	//JĂy[W̃^Cg
	CListBox m_listbox;			//Xg{bNX̑NX
	CEdit m_edit;				//eLXg{bNX̑NX
	int m_nValid;				//^Cg}~@\͗L
	CContainedWindow m_wndList;	//Xg{bNX̑NX

	//֐IuWFNg
	struct AddToListBox : public std::unary_function<const CString&, void>
	{
		CListBox& m_box;
		AddToListBox(CListBox& box) : m_box(box) { }
		result_type operator()(argument_type src)
		{
			m_box.AddString(src);
		}
	};

	//bZ[Wnh
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	//R}hnh
	void OnDelCmd(UINT /*wNotifyCode*/, int /*wID*/, HWND /*hWndCtl*/);
	void OnDelAllCmd(UINT /*wNotifyCode*/, int /*wID*/, HWND /*hWndCtl*/);
	void OnAddCmd(UINT /*wNotifyCode*/, int /*wID*/, HWND /*hWndCtl*/);
	void OnSelChange(UINT code, int id, HWND hWnd);
	void OnListKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);

	//֐
	void GetData();	//_CAOf[^̎擾
	BOOL DataExchange(BOOL bSaveAndValidate);	//Rg[̏Ԃƃf[^̕ϊ

public:
	//_CAÕ\[XID
	enum { IDD = IDD_PROPPAGE_CLOSETITLES };

	//RXgN^
	CCloseTitlesPropertyPage(const CString& strAddressBar);

	//DDX}bv
	BEGIN_DDX_MAP(CDLControlPropertyPage)
		DDX_CHECK(IDC_IGNORED_URL_VALID, m_nValid)
	END_DDX_MAP()

	//vpeBx[WƂẴI[o[Ch֐
	BOOL OnSetActive();
	BOOL OnKillActive();
	BOOL OnApply();

	//bZ[W}bv
	BEGIN_MSG_MAP(CCloseTitlesPropertyPage)
		MESSAGE_HANDLER(WM_INITDIALOG,OnInitDialog)
		MESSAGE_HANDLER(WM_DESTROY,OnDestroy)
		COMMAND_ID_HANDLER_EX(IDC_ADD_BUTTON, OnAddCmd)
		COMMAND_ID_HANDLER_EX(IDC_DELALL_BUTTON,OnDelAllCmd)
		COMMAND_ID_HANDLER_EX(IDC_DEL_BUTTON, OnDelCmd)
		COMMAND_HANDLER_EX(IDC_IGNORED_URL_LIST, LBN_SELCHANGE, OnSelChange)
		CHAIN_MSG_MAP(CPropertyPageImpl<CCloseTitlesPropertyPage>)
	ALT_MSG_MAP(1)
		MSG_WM_KEYUP(OnListKeyUp)
	END_MSG_MAP()
};
